/**
 * @(#)             Gr graphing application
 * @author          John Donovan
 *                  U.S. Geological Survey, Water Resources Division
 * @version         2007-05-01
 * Date started:    2007-03-01
 *
 * Copyright (C) 1998-2008 John M. Donovan
 * See the file Gr.java in the package gov.usgs.gr for licensing and
 * warranty information.  Also see license.txt in the package gov.usgs.
 */

package gov.usgs.gr.tools;

import java.util.*;
import gov.usgs.gr.data.*;

//==============================================================================
/**
 * Fills gaps in DataSeries using a constant value.  The gaps are
 * identified as any point from the series' list of deleted points that falls
 * between the series' first and last selected points.
 */
public class ConstantValueProvider implements SeriesValueProvider {
        
    // The value to provide.
    double m_value = Double.NaN;
//------------------------------------------------------------------------------
    /**
     * Creates an empty object.
     */
    public ConstantValueProvider() {
    }
    
//------------------------------------------------------------------------------
    /**
     * Creates an empty object.
     */
    public ConstantValueProvider(double value) {
        
        m_value = value;
    }
        
//------------------------------------------------------------------------------
    /**
     * Calculates the fill value at a certain point.
     */
    public void setValue(double value) {
    
        m_value = value;
    }
        
//------------------------------------------------------------------------------
    /**
     * Calculates the fill value at a certain point.
     */
    public double getValueAt(DoubleDataSeries series, double xPoint) {
    
        return m_value;
    }
}
