/**
 * @(#)             Gr graphing application
 * @author          John Donovan
 *                  U.S. Geological Survey, Water Resources Division
 * @version         2007-05-01
 * Date started:    2007-03-05
 *
 * Copyright (C) 1998-2008 John M. Donovan
 * See the file Gr.java in the package gov.usgs.gr for licensing and
 * warranty information.  Also see license.txt in the package gov.usgs.
 */

package gov.usgs.gr.tools;

import java.util.*;
import gov.usgs.gr.data.*;

//==============================================================================
/**
 * Fills gaps in DataSeries using an interpolated value.
 */
public class InterpolatedValueProvider implements SeriesValueProvider {
        
//------------------------------------------------------------------------------
    /**
     * Creates an empty object.
     */
    public InterpolatedValueProvider() {
    }
            
//------------------------------------------------------------------------------
    /**
     * Calculates the fill value at a certain point.
     */
    public double getValueAt(DoubleDataSeries series, double xPoint) {
    
        return series.getInterpolatedValue(xPoint);
    }
}
