/**
 * @(#)             Gr graphing application
 * @author          John Donovan
 *                  U.S. Geological Survey, Water Resources Division
 * @version         2005-01-28
 * Date started:    2000-09-15
 *
 * Copyright (C) 1998-2008 John M. Donovan
 * See the file Gr.java in the package gov.usgs.gr for licensing and
 * warranty information.  Also see license.txt in the package gov.usgs.
 */

package gov.usgs.gr.visual;


//==============================================================================
/**
 * An interface for determining a color for any value based on a certain
 * color scheme.
 */
public interface ColorScheme {

    /**
     * Return three item array containing Red, Green, and Blue indeces
     * between 0 and 1.  The color is determined by val.
     */
    public float[] getColor(double val);
}

