/**
 * @(#)             Gr graphing application
 * @author          John Donovan
 *                  U.S. Geological Survey, Water Resources Division
 * @version         2002-02-13
 * Date started:    1998-06-11
 *
 * Copyright (C) 1998-2008 John M. Donovan
 * See the file Gr.java in the package gov.usgs.gr for licensing and
 * warranty information.  Also see license.txt in the package gov.usgs.
 */

package gov.usgs.gr.visual.gui;

import javax.swing.*;
import java.util.*;

//==============================================================================
/**
 * A tool bar for some of the most frequently used commands.
 */
public class GrToolBar extends JToolBar {

//------------------------------------------------------------------------------
/**
 * Create a tool from a list of actions.
 * @param toolBarActions    A list of actions that the tool bar should show.
 */
    public GrToolBar(List toolBarActions) {

        // Add each action to the tool bar individually.
        for (int i = 0; i < toolBarActions.size(); i++) {
            add((Action)toolBarActions.get(i));
        }

        // Set the layout to show the buttons in a line.
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    }
}
