/**
 * @(#)             Gr graphing application
 * @author          John Donovan
 *                  U.S. Geological Survey, Water Resources Division
 * @version         2004-01-26
 * Date started:    2003-07-02
 *
 * Copyright (C) 1998-2008 John M. Donovan
 * See the file Gr.java in the package gov.usgs.gr for licensing and
 * warranty information.  Also see license.txt in the package gov.usgs.
 */

package gov.usgs.gr.visual.gui;

import gov.usgs.gr.*;
import gov.usgs.gr.visual.*;

//==============================================================================
/**
 * An interface for providing a GUI panel for dealing with a certain type of
 * content.
 */
public interface GuiPanelProvider {

    /**
     * Return a JPanel that is appropriate for handling the content on the
     * current page.
     */
    public javax.swing.JPanel getPanel();

    /**
     * Tells this interface what the current controller and page are.
     */
    public void setControllerAndPage(GrController grCon, PageOfGraphs page);
}




