/**
 * @(#)             Gr graphing application
 * @author          John Donovan
 *                  U.S. Geological Survey, Water Resources Division
 * @version         2001-02-01
 * Date started:    1999-03-24
 *
 * Copyright (C) 1998-2008 John M. Donovan
 * See the file Gr.java in the package gov.usgs.gr for licensing and
 * warranty information.  Also see license.txt in the package gov.usgs.
 */

 package gov.usgs.gr.visual.gui;

import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.tree.*;

//==============================================================================
class JComponentCellRenderer extends DefaultTreeCellRenderer
	implements TableCellRenderer {

//------------------------------------------------------------------------------
	public Component getTableCellRendererComponent(JTable table, Object value,
    	boolean isSelected, boolean hasFocus, int row, int column) {

        return (JComponent)value;
    }


//------------------------------------------------------------------------------
	public Component getTreeCellRendererComponent(JTree tree, Object value,
    	boolean sel, boolean expanded, boolean leaf, int row,
        boolean hasFocus) {

        super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf,
        	row, hasFocus);

        gov.usgs.gr.GrObject gro = (gov.usgs.gr.GrObject)value;
        setIcon(gro.getTreeIcon());

        setToolTipText(null); //no tool tip

		return this;
	}
}

