/**
 * @(#)             Gr graphing application
 * @author          John Donovan
 *                  U.S. Geological Survey, Water Resources Division
 * @version         2001-02-01
 * Date started:    2000-10-12
 *
 * Copyright (C) 1998-2008 John M. Donovan
 * See the file Gr.java in the package gov.usgs.gr for licensing and
 * warranty information.  Also see license.txt in the package gov.usgs.
 */

package gov.usgs.gr.visual.gui;


//==============================================================================
/**
 * An interface for determining a color for any value based on a certain
 * color scheme.
 */
public interface PageProxy {

    /**
     * Return a new instance of the type of page that goes with this panel.
     */
    public gov.usgs.gr.visual.PageOfGraphs setNewPage();
    /**
     * Set the page.
     */
    public void setPage(gov.usgs.gr.visual.PageOfGraphs page);
    /**
     * Set the controller.
     */
    public void setController(gov.usgs.gr.GrController grCon);
    /**
     * Send a repaint message to the panel component.
     */
    public void repaint();
    /**
     * Get the panel component.
     */
    public java.awt.Component getComponent();
}

