/**
 * @(#)             Gr graphing application
 * @author          John Donovan
 *                  U.S. Geological Survey, Water Resources Division
 * @version         2003-08-14
 * Date started:    2003-08-14
 *
 * Copyright (C) 1998-2008 John M. Donovan
 * See the file Gr.java in the package gov.usgs.gr for licensing and
 * warranty information.  Also see license.txt in the package gov.usgs.
 */

package gov.usgs.gr.visual.ps;

/**
 * An interface that identifies objects which can draw to a
 * PostScript file within a PsGraph.
 */
public interface PsDrawingObject {
    /**
     * Tells the object what it should use as its drawing area within
     * the graph area.
     */
    public void setLocalRect(java.awt.geom.Rectangle2D.Double local);
    /** Tells the object what the axis range of the parent graph is. */
    public void setAxisRange(double minx, double maxx, double miny,double maxy);
    /** The PS Options object with formatting parameters */
    public PsOptions psOptions = new PsOptions();
}
