/**
 * @(#)             Gr graphing application
 * @author          John Donovan
 *                  U.S. Geological Survey, Water Resources Division
 * @version         2005-11-04
 * Date started:    1999-01-21
 *
 * Copyright (C) 1998-2008 John M. Donovan
 * See the file Gr.java in the package gov.usgs.gr for licensing and
 * warranty information.  Also see license.txt in the package gov.usgs.
 */

package gov.usgs.gr.visual.ps;

import java.io.*;
import gov.usgs.gr.visual.*;

//==============================================================================
/**
 * The X version of the axis object.
 */
public class PsXAxis extends PsAxis implements PsElement {


//------------------------------------------------------------------------------
/**
 * Empty constructor.
 */
    public PsXAxis () {

    	m_dimension = 0;

        setDefaults("gov.usgs.gr.visual.ps.PsXAxis");
    }

//------------------------------------------------------------------------------
/**
 * Passes parameters to the Axis constructor.
 * @param limits	The limits object telling what segment of the axis should
 *					be represented.
 * @param opposingLimits	The opposing axis' limits.  Used to determine the
 *							how the length of tick marks when drawing in
 *							graph coordinates.
 */
    public PsXAxis (Zoom zoom, Zoom opposingZoom) {

        super(zoom, opposingZoom);
    	m_dimension = 0;

        setDefaults("gov.usgs.gr.visual.ps.PsXAxis");
    }

//------------------------------------------------------------------------------
/**
 * Create a new axis by copying an existing one.
 * @param axis	The axis to be copied.
 */
    public PsXAxis (Axis axis) {

    	super(axis);
    	m_dimension = 0;
    }

//------------------------------------------------------------------------------
/**
 * Create a string representation of this object.
 * @return  The string that describes this object.
 */
    public String toString() {

    	String s = "X Axis";

        return s;
 	}
}


