/**
 * @(#)             Gr graphing application
 * @author          John Donovan
 *                  U.S. Geological Survey, Water Resources Division
 * @version         2007-07-06
 * Date started:    2007-07-06
 *
 * Copyright (C) 1998-2008 John M. Donovan
 * See the file Gr.java in the package gov.usgs.gr for licensing and
 * warranty information.  Also see license.txt in the package gov.usgs.
 */

package gov.usgs.sfhydro.data.gui;

import javax.swing.JDialog;

public class ArcGridAsciiOptionsPanel extends javax.swing.JPanel {
    
    protected JDialog m_dialog = null;

    /** Creates new form ArcGridAsciiOptions */
    public ArcGridAsciiOptionsPanel() {
        initComponents();
    }
    
    public void setDialog(JDialog dialog) {
	
	m_dialog = dialog;
    }
    
    public void setFileUnits(int index) {
	
	fileUnitsComboBox.setSelectedIndex(index);
    }
    
    public void setDisplayUnits(int index) {
	
	displayUnitsComboBox.setSelectedIndex(index);
    }
    
    public void setFileMultiplier(double val) {
	
            fileMultiplierTextField.setText("" + val);
    }
    
    public void setDisplayMultiplier(double val) {
	
        displayMultiplierTextField.setText("" + val);
    }
    
    public void setFileShift(double val) {
	
        fileShiftTextField.setText("" + val);
    }
    
    public void setDisplayShift(double val) {
	
        displayShiftTextField.setText("" + val);
    }
    
    public int getFileUnits() {
	
	return fileUnitsComboBox.getSelectedIndex();
    }
    
    public int getDisplayUnits() {
	
	return displayUnitsComboBox.getSelectedIndex();
    }
    
    public double getFileMultiplier() {
	
        try {
            return Double.parseDouble(fileMultiplierTextField.getText());
        } catch (NumberFormatException ex) {
            return 1;
        }
    }
    
    public double getDisplayMultiplier() {
	
        try {
            return Double.parseDouble(displayMultiplierTextField.getText());
        } catch (NumberFormatException ex) {
            return 1;
        }
    }
    
    public double getFileShift() {
	
        try {
            return Double.parseDouble(fileShiftTextField.getText());
        } catch (NumberFormatException ex) {
            return 0;
        }
    }
    
    public double getDisplayShift() {
	
        try {
            return Double.parseDouble(displayShiftTextField.getText());
        } catch (NumberFormatException ex) {
            return 0;
        }
    }
    
    public void enableFileFields(boolean val) {
	
        fileUnitsComboBox.setEnabled(val);
        fileMultiplierTextField.setEnabled(val);
        fileShiftTextField.setEnabled(val);
    }
    
    public void enableDisplayFields(boolean val) {
	
        displayUnitsComboBox.setEnabled(val);
        displayMultiplierTextField.setEnabled(val);
        displayShiftTextField.setEnabled(val);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        fileMultiplierTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        displayUnitsComboBox = new javax.swing.JComboBox();
        fileUnitsComboBox = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        displayMultiplierTextField = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        displayShiftTextField = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        fileShiftTextField = new javax.swing.JTextField();
        jSeparator1 = new javax.swing.JSeparator();
        jSeparator2 = new javax.swing.JSeparator();
        jButton2 = new javax.swing.JButton();

        jLabel1.setText("Depths in the file are in");

        jLabel2.setText(" multiplied by ");

        fileMultiplierTextField.setText("1");

        jLabel3.setText("Depths on the screen should be displayed in");

        displayUnitsComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Meters", "Feet" }));

        fileUnitsComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Meters", "Feet" }));

        jLabel4.setText(" multiplied by ");

        displayMultiplierTextField.setText("1");

        jLabel5.setText("and then shifted by ");

        displayShiftTextField.setText("0");

        jLabel6.setText("and shifted by ");

        fileShiftTextField.setText("0");

        jButton2.setText("OK");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSeparator2, javax.swing.GroupLayout.DEFAULT_SIZE, 358, Short.MAX_VALUE)
                    .addComponent(jLabel1)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(fileUnitsComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel2))
                            .addComponent(jLabel6))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(fileShiftTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)
                            .addComponent(fileMultiplierTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)))
                    .addComponent(jSeparator1, javax.swing.GroupLayout.DEFAULT_SIZE, 358, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(displayUnitsComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel4))
                            .addComponent(jLabel5))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(displayShiftTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)
                            .addComponent(displayMultiplierTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)))
                    .addComponent(jLabel3)
                    .addComponent(jButton2, javax.swing.GroupLayout.Alignment.TRAILING))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(fileUnitsComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2)
                    .addComponent(fileMultiplierTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(fileShiftTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(displayUnitsComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4)
                    .addComponent(displayMultiplierTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(displayShiftTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton2)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed

        m_dialog.dispose();
    }//GEN-LAST:event_jButton2ActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField displayMultiplierTextField;
    private javax.swing.JTextField displayShiftTextField;
    private javax.swing.JComboBox displayUnitsComboBox;
    private javax.swing.JTextField fileMultiplierTextField;
    private javax.swing.JTextField fileShiftTextField;
    private javax.swing.JComboBox fileUnitsComboBox;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    // End of variables declaration//GEN-END:variables
    
}
