/**
 * @(#)             Gr graphing application
 * @author          John Donovan
 *                  U.S. Geological Survey, Water Resources Division
 * @version         2008-03-12
 * Date started:    2006-11-05
 *
 * Copyright (C) 1998-2008 John M. Donovan
 * See the file Gr.java in the package gov.usgs.gr for licensing and
 * warranty information.  Also see license.txt in the package gov.usgs.
 */

package gov.usgs.sfhydro.si3d.gui;

import java.io.File;
import java.util.Enumeration;
import javax.swing.AbstractListModel;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;

/**
 *
 * @author  jmd
 */
public class BoundarySetManager extends javax.swing.JFrame {

    boolean m_bBoundariesPresent = false;
    DefaultListModel m_setNames = new DefaultListModel();
    AbstractListModel m_setListModel = null;
    GrBathCalcController m_grCon = null;
    String m_suggestedSuffix = "";
    String m_fileSuffix = "_bnd.xml";

    /** Creates new form BoundarySetManager */
    public BoundarySetManager() {
	initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jScrollPane1 = new javax.swing.JScrollPane();
        boundarySetList = new javax.swing.JList();
        saveButton = new javax.swing.JButton();
        removeButton = new javax.swing.JButton();
        doneButton = new javax.swing.JButton();
        addButton = new javax.swing.JButton();
        replaceButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        boundarySetList.setFont(new java.awt.Font("SansSerif", 1, 14));
        boundarySetList.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        boundarySetList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                boundarySetListValueChanged(evt);
            }
        });

        jScrollPane1.setViewportView(boundarySetList);

        saveButton.setFont(new java.awt.Font("SansSerif", 1, 14));
        saveButton.setText("Save Current");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        removeButton.setFont(new java.awt.Font("SansSerif", 1, 14));
        removeButton.setText("Delete Set");
        removeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeButtonActionPerformed(evt);
            }
        });

        doneButton.setFont(new java.awt.Font("SansSerif", 1, 14));
        doneButton.setText("Done");
        doneButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                doneButtonActionPerformed(evt);
            }
        });

        addButton.setFont(new java.awt.Font("SansSerif", 1, 14));
        addButton.setText("Add to Current");
        addButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addButtonActionPerformed(evt);
            }
        });

        replaceButton.setFont(new java.awt.Font("SansSerif", 1, 14));
        replaceButton.setText("Replace Current");
        replaceButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                replaceButtonActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("SansSerif", 1, 14));
        jLabel1.setText("Available Boundary Sets");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 220, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(saveButton, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(doneButton, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(addButton)
                    .addComponent(replaceButton)
                    .addComponent(removeButton))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, addButton, doneButton, removeButton, replaceButton, saveButton);

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(saveButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(addButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(replaceButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(removeButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 69, Short.MAX_VALUE)
                        .addComponent(doneButton))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 213, Short.MAX_VALUE)))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void removeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeButtonActionPerformed

	int selectedIndex = boundarySetList.getSelectedIndex();
        String setName = (String)m_setNames.getElementAt(selectedIndex);

        int answer = JOptionPane.showConfirmDialog(this,
            "Delete " + setName + "?", "Verify Deletion",
            JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);

        if (answer != JOptionPane.YES_OPTION)
            return;

        String userHome = System.getProperty("user.home");
        userHome.replace('\\', '/');

        String dirName = userHome + "/GrBathCalc/Boundaries";

        File file = new File(dirName + "/" + setName + m_fileSuffix);
        file.delete();
        m_setNames.remove(selectedIndex);

//        boundarySetList.invalidate();
	boundarySetList.setSelectedIndex(0);
//	boundarySetList.setModel(m_setListModel);


    }//GEN-LAST:event_removeButtonActionPerformed

    private void addButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addButtonActionPerformed

	int selectedIndex = boundarySetList.getSelectedIndex();
	String setName = (String)m_setNames.getElementAt(selectedIndex);
	if ((selectedIndex == 0 && !m_bBoundariesPresent) ||
	    (selectedIndex == 1 && m_bBoundariesPresent)) {

	    setName = null;
	}

        m_grCon.openBoundaries(setName, false);

    }//GEN-LAST:event_addButtonActionPerformed

    private void replaceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_replaceButtonActionPerformed

	int selectedIndex = boundarySetList.getSelectedIndex();
	String setName = (String)m_setNames.getElementAt(selectedIndex);
	if ((selectedIndex == 0 && !m_bBoundariesPresent) ||
	    (selectedIndex == 1 && m_bBoundariesPresent)) {

	    setName = null;
	}

        m_grCon.openBoundaries(setName, true);

    }//GEN-LAST:event_replaceButtonActionPerformed

    private void boundarySetListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_boundarySetListValueChanged

	int selectedIndex = boundarySetList.getSelectedIndex();
	// Disable save if "NO BOUNDARIES" is selected.
	if ((selectedIndex == 0 && !m_bBoundariesPresent) ||
	    (selectedIndex == 1 && m_bBoundariesPresent)) {

	    saveButton.setEnabled(false);
	}
	else {
	    saveButton.setEnabled(true);
	}

	// Disable add and remove if "NO" or "CURRENT" are selected
	if (selectedIndex == 0 ||
	    (selectedIndex == 1 && m_bBoundariesPresent)) {

	    addButton.setEnabled(false);
	    removeButton.setEnabled(false);
	}
	else {
	    addButton.setEnabled(true);
	    removeButton.setEnabled(true);
	}

	// Disable replace if "CURRENT" is selected or "NO" is selected and
	// there are no other choices
	if (selectedIndex == 0) {
	    replaceButton.setEnabled(false);
	}
	else {
	    replaceButton.setEnabled(true);
	}

    }//GEN-LAST:event_boundarySetListValueChanged

    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed

	int selectedIndex = boundarySetList.getSelectedIndex();
	String setName = (String)m_setNames.getElementAt(selectedIndex);
	if (boundarySetList.getSelectedIndex() == 0 && m_bBoundariesPresent) {
            String userHome = System.getProperty("user.home");
            userHome.replace('\\', '/');

            String dirName = userHome + "/GrBathCalc/Boundaries";

            int setIndex = 1;
            setName = null;
            do {
                setName = String.format("%02d", setIndex) + m_suggestedSuffix;
                File file = new File(dirName + "/" + setName + m_fileSuffix);
                if (file.exists()) {
                    setName = null;
                    setIndex++;
                }
            } while (setName == null && setIndex < 1000);

            if (setName == null)
                setName = "MY BOUNDARIES";
	}

        setName = (String)JOptionPane.showInputDialog(this,
            "Save the boundary set as", "Verify Name",
            JOptionPane.QUESTION_MESSAGE, null, null, setName);

        boolean bAlreadyListed = false;
	if (setName != null) {
	    m_grCon.saveBoundaries(setName.toUpperCase());

            Enumeration setEnum = m_setNames.elements();
            while (setEnum.hasMoreElements()) {
                String str = (String)setEnum.nextElement();
                if (str.equals(setName)) {
                    bAlreadyListed = true;
                    break;
                }
            }

            if (!bAlreadyListed) {
                m_setNames.addElement(setName);

//                boundarySetList.invalidate();
                boundarySetList.setSelectedIndex(m_setNames.size() - 1);
//                boundarySetList.setModel(m_setListModel);
            }
	}

    }//GEN-LAST:event_saveButtonActionPerformed

    private void doneButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_doneButtonActionPerformed

	dispose();
    }//GEN-LAST:event_doneButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
	java.awt.EventQueue.invokeLater(new Runnable() {
	    public void run() {
		new BoundarySetManager().setVisible(true);
	    }
	});
    }

    public void setController(GrBathCalcController grCon) {

	m_grCon = grCon;
    }

    public void setSuggestedSuffix(String suffix) {

	m_suggestedSuffix = suffix;
    }

    public void setBoundariesPresent(boolean bPresent) {

	m_bBoundariesPresent = bPresent;
	m_setNames.clear();
	if (bPresent)
	    m_setNames.addElement("< CURRENT BOUNDARIES >");
	m_setNames.addElement("< NO BOUNDARIES >");

	String userHome = System.getProperty("user.home");
	userHome.replace('\\', '/');

	String dirName = userHome + "/GrBathCalc/Boundaries";
	File bndDir = new File(dirName);
	File[] files = bndDir.listFiles();
	if (files != null) {
	    for (File file : files) {
		String fileName = file.getName();
		if (fileName.endsWith(m_fileSuffix)) {
		    int endIndex = fileName.length() - 8;
		    String setName = fileName.substring(0, endIndex);
		    m_setNames.addElement(setName.toUpperCase());
		}

	    }
	}

//	m_setListModel = new javax.swing.AbstractListModel() {
//	    public int getSize() { return m_setNames.size(); }
//	    public Object getElementAt(int i) {
//                return m_setNames.get(i);
//            }
//	};
        boundarySetList.setModel(m_setNames);
//	boundarySetList.setModel(m_setListModel);

	boundarySetList.setSelectedIndex(0);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addButton;
    private javax.swing.JList boundarySetList;
    private javax.swing.JButton doneButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton removeButton;
    private javax.swing.JButton replaceButton;
    private javax.swing.JButton saveButton;
    // End of variables declaration//GEN-END:variables

}
