/*
 * InitialInputFrame.java
 *
 * Created on October 27, 2006, 6:58 PM
 */

package gov.usgs.sfhydro.si3d.gui;

import java.text.ParseException;
import javax.swing.JFormattedTextField;
import javax.swing.JFormattedTextField.AbstractFormatter;
import javax.swing.JOptionPane;

/**
 *
 * @author  jmd
 */
public class InitialInputFrame extends javax.swing.JFrame {
    
    double m_spacing = 13;
    
    /** Creates new form InitialInputFrame */
    public InitialInputFrame() {
	initComponents();
    }
    public InitialInputFrame(GrBathCalcGuiOptions options) {
	
	m_spacing = options.m_gridSpacing;
	initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        gridSpacingLabel = new javax.swing.JLabel();
        continueButton = new javax.swing.JButton();
        quitButtton = new javax.swing.JButton();
        gridSpacingFormattedTextField = new javax.swing.JFormattedTextField();
        gridSpacingFormattedTextField.setValue(new Long(Math.round(m_spacing)));
        gridSpacingFormattedTextField.setFocusLostBehavior(JFormattedTextField.COMMIT);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        gridSpacingLabel.setFont(new java.awt.Font("SansSerif", 1, 14));
        gridSpacingLabel.setText("Grid Spacing in Meters");

        continueButton.setFont(new java.awt.Font("SansSerif", 1, 14));
        continueButton.setText("Continue");
        continueButton.setToolTipText("Open the calculator using the grid spacing entered above");
        continueButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                continueButtonActionPerformed(evt);
            }
        });

        quitButtton.setFont(new java.awt.Font("SansSerif", 1, 14));
        quitButtton.setText("Quit");
        quitButtton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                quitButttonActionPerformed(evt);
            }
        });

        gridSpacingFormattedTextField.setToolTipText("");
        gridSpacingFormattedTextField.setFont(new java.awt.Font("SansSerif", 1, 14));
        gridSpacingFormattedTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                gridSpacingFormattedTextFieldKeyTyped(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(gridSpacingLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 248, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(gridSpacingFormattedTextField, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 140, Short.MAX_VALUE)
                            .addGroup(layout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 41, Short.MAX_VALUE)
                                .addComponent(continueButton)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(quitButtton)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {continueButton, quitButtton});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(gridSpacingLabel)
                .addGap(2, 2, 2)
                .addComponent(gridSpacingFormattedTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 61, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(quitButtton)
                    .addComponent(continueButton))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void gridSpacingFormattedTextFieldKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_gridSpacingFormattedTextFieldKeyTyped
	
	if (evt.getKeyChar() != evt.VK_ENTER)
	    return;
	
	if (parseTextField()) {
	    dispose();
	} else {
	    JOptionPane.showMessageDialog(this,
		"The value is not valid.  Please enter an integer value.",
		"Parsing Error",
		JOptionPane.ERROR_MESSAGE);
	}
    }//GEN-LAST:event_gridSpacingFormattedTextFieldKeyTyped
    
    private void continueButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_continueButtonActionPerformed
	
	if (parseTextField()) {
	    dispose();
	} else {
	    JOptionPane.showMessageDialog(this,
		"The value is not valid.  Please enter an integer value.",
		"Parsing Error",
		JOptionPane.ERROR_MESSAGE);
	}
    }//GEN-LAST:event_continueButtonActionPerformed
    
    private void quitButttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_quitButttonActionPerformed
	
	System.exit(0);
    }//GEN-LAST:event_quitButttonActionPerformed
    
    public double getSpacing() {
	
	return m_spacing;
    }
    
    public boolean parseTextField() {
	
	AbstractFormatter formatter =
	    gridSpacingFormattedTextField.getFormatter();
	if (formatter != null) {
	    String text = gridSpacingFormattedTextField.getText();
	    try {
		m_spacing = (Long)formatter.stringToValue(text);
		return true;
	    } catch (ParseException pe) {
		return false;
	    }
	}
	
	return false;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
	java.awt.EventQueue.invokeLater(new Runnable() {
	    public void run() {
		new InitialInputFrame().setVisible(true);
	    }
	});
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton continueButton;
    private javax.swing.JFormattedTextField gridSpacingFormattedTextField;
    private javax.swing.JLabel gridSpacingLabel;
    private javax.swing.JButton quitButtton;
    // End of variables declaration//GEN-END:variables
    
}
